
#ifndef  _GROMADA_TYPES_H_
#define  _GROMADA_TYPES_H_


#include  <sys/types.h>


#ifdef  __cplusplus
extern "C" {
#endif


// signed integers
typedef  char       Int8;
typedef  short      Int16;
typedef  long       Int32;
typedef  long long  Int64;

// unsigned integers
typedef  unsigned char       Uint8;
typedef  unsigned short      Uint16;
typedef  unsigned long       Uint32;
typedef  unsigned long long  Uint64;

typedef  unsigned int  Uint;
typedef  Uint8         Uchar;
typedef  Uint16        Ushort;
typedef  Uint32        Ulong;
typedef  Uint32        Usize;

typedef  Uint    Bool;
typedef  Uint8   Bool8;
typedef  Uint32  Bool32;

typedef  void*        Pointer;
typedef  const void*  PointerConst;


#ifndef  TRUE
#  define  TRUE  1
#endif
#ifndef  FALSE
#  define  FALSE  0
#endif

#ifndef  NULL
#  ifdef  __cplusplus
#    define  NULL  (0L)
#  else
#    define  NULL  ((void*) 0)
#  endif
#endif


#ifdef __cplusplus
}
#endif


#endif  // _GROMADA_TYPES_H_
